#!/usr/bin/ruby -Ks
#
require '/opt/yklook/swing'
require '/opt/yklook/swingcanvas'

class SimpleGraphic < YKLookMain
	ShapeStr = [ "(lw)", "`(lw)",
				"ȉ~(lw)", "~(lw)",
				"", "摜", "(}EX)", "`(}EX)" ]
	ShapeKey = [ "line", "rect", "rect", "arc", "str", "img", "drag", "drag" ]
	ShapeFill= [ false, true, true, true, false, false, false, true ]
	ShapeCursor = [ false, false, false, false, false, true, true, true ]
	FontStr = [ "Dialog", "DialogInput", "MonoSpaced", "Serif", "SansSerif" ]
	StyStr = [ "ʏ", "", "Α", "+Α" ]
	StyKey = [ 'PLAIN', 'BOLD', 'ITALIC', 'BOLD:ITALIC' ]
	SizStr = [ "9", "10", "12", "14", "16", "18", "20",
				"22", "24", "26", "28", "30", "32", "34",
				"36", "38", "40", "42", "44", "46", "48" ]
	ImgGif = [ "dot_031.gif", "dot_032.gif", "dot_008.gif", "dot_050.gif",
				"dot_051.gif", "dot_052.gif", "dot_053.gif", "dot_055.gif" ]
	ImgHelp = [ "_Ђۂ摜", "s~bhۂ摜", "", "pgJ[",
					"h", "~}", "s@P", "s@Q" ]
	ColStr = [ "","","","","D","" ]
	ColCol = [ 'red', 'green', 'blue', 'black', 'gray', 'yellow' ]

	def yki_size()
		return [640, 480]
	end

	def yki_title()
		return 'OtBbN`@\'
	end

	def yki_make_display()
		basePan  = YKLookPanelFlow.new()
		baseBox  = YKLookPanelBox.new( 'horizontal' )
		toolBox  = YKLookPanelBox.new( 'vertical' )
		spacer   = YKLookBoxFiller.new( 10, 0 )
		miscPane = YKLookPanelCard.new().yk_set_tag('shapeMisc')
		colorBox = YKLookPanelGrid.new( 2, 3, [5, 5] )
		imgGrp   = YKLookButtonGroup.new()
		linePan  = YKLookPanelGridBag.new()
		rectPan  = YKLookPanelGridBag.new()
		arcPan   = YKLookPanelGridBag.new()
		strPan   = YKLookPanelGridBag.new()
		imgPan   = YKLookPanelGridBag.new()
		dragPan  = YKLookPanelGridBag.new()
		canvas   = YKLookCanvas.new( 400, 400 ).yk_set_tag('canvas')
		shapeSel = YKLookPopupList.new( ShapeStr ).yk_set_tag('shapeSel')
		drawFill = YKLookCheckBox.new( "hԂ" ).yk_set_tag('drawFill')
		drawFill.yk_set_enabled( false )
		clearBtn = YKLookButton.new( "Zbg" )
		line1x   = YKLookTextField.new(  5, "100" ).yk_set_tag( 'line1x' )
		line1y   = YKLookTextField.new(  5, "150" ).yk_set_tag( 'line1y' )
		line2x   = YKLookTextField.new(  5, "300" ).yk_set_tag( 'line2x' )
		line2y   = YKLookTextField.new(  5, "350" ).yk_set_tag( 'line2y' )
		rect1x   = YKLookTextField.new(  5, "140" ).yk_set_tag( 'rect1x' )
		rect1y   = YKLookTextField.new(  5, "150" ).yk_set_tag( 'rect1y' )
		rect1w   = YKLookTextField.new(  5, "120" ).yk_set_tag( 'rect1w' )
		rect1h   = YKLookTextField.new(  5, "100" ).yk_set_tag( 'rect1h' )
		arc1x    = YKLookTextField.new(  5,  "40" ).yk_set_tag( 'arc1x' )
		arc1y    = YKLookTextField.new(  5, "100" ).yk_set_tag( 'arc1y' )
		arc1w    = YKLookTextField.new(  5, "120" ).yk_set_tag( 'arc1w' )
		arc1h    = YKLookTextField.new(  5, "100" ).yk_set_tag( 'arc1h' )
		arc1s    = YKLookTextField.new(  5,  "30" ).yk_set_tag( 'arc1s' )
		arc1a    = YKLookTextField.new(  5, "300" ).yk_set_tag( 'arc1a' )
		str1x    = YKLookTextField.new(  5, "200" ).yk_set_tag( 'str1x' )
		str1y    = YKLookTextField.new(  5,  "50" ).yk_set_tag( 'str1y' )
		str1s    = YKLookTextField.new( 10, "YKLook" ).yk_set_tag( 'str1s' )
		fontSel  = YKLookPopupList.new( FontStr ).yk_set_tag( 'fontSel' )
		stySel   = YKLookPopupList.new( StyStr  ).yk_set_tag( 'stySel' )
		sizSel   = YKLookComboBox.new( SizStr  ).yk_set_tag( 'sizSel' )
		labColor = YKLookLabel.new( "" ).yk_set_tag( 'labColor' )

		labColor.yk_set_font( YKLookFont.new( 'Dialog', 'P', 32 ) )
		labColor.yk_set_fore( 'black' )

		drawFill.yk_set_tooltip( "`@Fĝ/hԂ" )
		clearBtn.yk_set_tooltip( "E̕\ׂď" )
		line1x  .yk_set_tooltip( "̊JnʒuwW" )
		line1y  .yk_set_tooltip( "̊JnʒuxW" )
		line2x  .yk_set_tooltip( "̏IʒuwW" )
		line2y  .yk_set_tooltip( "̏IʒuxW" )
		rect1x  .yk_set_tooltip( "`͈͂̍[ʒu" )
		rect1y  .yk_set_tooltip( "`͈͂̏[ʒu" )
		rect1w  .yk_set_tooltip( "`͈͂̕" )
		rect1h  .yk_set_tooltip( "`͈͂̍" )
		arc1x   .yk_set_tooltip( "~̍[ʒu" )
		arc1y   .yk_set_tooltip( "~̏[ʒu" )
		arc1w   .yk_set_tooltip( "~̕" )
		arc1h   .yk_set_tooltip( "~̍" )
		arc1s   .yk_set_tooltip( "`悷ʂ̊Jnpx(0`360)" )
		arc1a   .yk_set_tooltip( "`悷ʂ̊px̗(0`360)" )
		str1x   .yk_set_tooltip( "̍̂wW" )
		str1y   .yk_set_tooltip( "̍̂xW" )
		str1s   .yk_set_tooltip( "`悷镶" )

		gbce = { 'anchor' => 'E' }
		gbcw = { 'anchor' => 'W' , 'gridwidth' => nil }

		linePan.yk_add( YKLookLabel.new( "n_ X: " ), gbce )
		linePan.yk_add( line1x                      , gbcw )
		linePan.yk_add( YKLookLabel.new( "n_ Y: " ), gbce )
		linePan.yk_add( line1y                      , gbcw )
		linePan.yk_add( YKLookLabel.new( "I_ X: " ), gbce )
		linePan.yk_add( line2x                      , gbcw )
		linePan.yk_add( YKLookLabel.new( "I_ Y: " ), gbce )
		linePan.yk_add( line2y                      , gbcw )

		rectPan.yk_add( YKLookLabel.new( " X: " ), gbce )
		rectPan.yk_add( rect1x                      , gbcw )
		rectPan.yk_add( YKLookLabel.new( " Y: " ), gbce )
		rectPan.yk_add( rect1y                      , gbcw )
		rectPan.yk_add( YKLookLabel.new( "@@: " ), gbce )
		rectPan.yk_add( rect1w                      , gbcw )
		rectPan.yk_add( YKLookLabel.new( "@: " ), gbce )
		rectPan.yk_add( rect1h                      , gbcw )

		arcPan.yk_add( YKLookLabel.new( " X: " ), gbce )
		arcPan.yk_add( arc1x                       , gbcw )
		arcPan.yk_add( YKLookLabel.new( " Y: " ), gbce )
		arcPan.yk_add( arc1y                       , gbcw )
		arcPan.yk_add( YKLookLabel.new( "@@: " ), gbce )
		arcPan.yk_add( arc1w                       , gbcw )
		arcPan.yk_add( YKLookLabel.new( "@: " ), gbce )
		arcPan.yk_add( arc1h                       , gbcw )
		arcPan.yk_add( YKLookLabel.new( "Jnp: " ), gbce )
		arcPan.yk_add( arc1s                       , gbcw )
		arcPan.yk_add( YKLookLabel.new( "@px: " ), gbce )
		arcPan.yk_add( arc1a                       , gbcw )

		strPan.yk_add( YKLookLabel.new( " X: " ), gbce )
		strPan.yk_add( str1x                        , gbcw )
		strPan.yk_add( YKLookLabel.new( " Y: " ), gbce )
		strPan.yk_add( str1y                        , gbcw )
		strPan.yk_add( YKLookLabel.new( ": " ), gbce )
		strPan.yk_add( str1s                         , gbcw )
		strPan.yk_add( YKLookLabel.new( "tHg: " ), gbce )
		strPan.yk_add( fontSel                       , gbcw )
		strPan.yk_add( YKLookLabel.new( "X^C: " ), gbce )
		strPan.yk_add( stySel                        , gbcw )
		strPan.yk_add( YKLookLabel.new( "@TCY: " ), gbce )
		strPan.yk_add( sizSel                        , gbcw )

		ImgGif.each_with_index() do |gif,idx|
			img = YKLookImage.yk_from_file( gif )
			btn = YKLookToggleButton.new( img )
			btn.yk_set_tooltip( ImgHelp[idx] )
			imgGrp.yk_add( btn )
			imgPan.yk_add( btn, ((idx % 2) == 0) ? gbce : gbcw )
		end
		imgPan.yk_add( YKLookLabel.new( " " ), gbcw )
		imgPan.yk_add( YKLookLabel.new( "摜IE̕\" ), gbcw )
		imgPan.yk_add( YKLookLabel.new( "NbNĂ" ), gbcw )

		dragPan.yk_add( YKLookLabel.new( " " ), gbcw )
		dragPan.yk_add( YKLookLabel.new( " " ), gbcw )
		dragPan.yk_add( YKLookLabel.new( "E̕\}EX" ), gbcw )
		dragPan.yk_add( YKLookLabel.new( "hbOĂ" ), gbcw )
		dragPan.yk_add( YKLookLabel.new( " " ), gbcw )
		dragPan.yk_add( labColor, gbcw )
		dragPan.yk_add( YKLookLabel.new( " " ), gbcw )
		dragPan.yk_add( YKLookLabel.new( "̐FŐ}`܂B" ), gbcw )
		dragPan.yk_add( YKLookLabel.new( "FւƂ͉" ), gbcw )
		dragPan.yk_add( YKLookLabel.new( "{^Ă" ), gbcw )

		ColStr.each_with_index() do |str,idx|
			col = YKLookColor.new( ColCol[idx] )
			btn = YKLookButton.new( str ).yk_set_tag( 'colorBtn' )
			btn.yk_set_fore( col )
			btn.yk_set_preferred_size( [50,nil], [50,40] )
			btn.yk_set_minimum_size( 20, 10 )
			btn.yk_set_maximum_size( 50, 40 )
			btn.yk_set_tooltip( "w肳ꂽFŕ`" )
			btn.yk_set_listener( :fn_actionColorButton )
			colorBox.yk_add( btn )
		end

		miscPane.yk_add( linePan, "line" )
		miscPane.yk_add( rectPan, "rect" )
		miscPane.yk_add( arcPan , "arc"  )
		miscPane.yk_add( strPan , "str"  )
		miscPane.yk_add( imgPan , "img"  )
		miscPane.yk_add( dragPan, "drag"  )
		toolBox.yk_add( shapeSel )
		toolBox.yk_add( miscPane )
		toolBox.yk_add( drawFill )
		toolBox.yk_add( colorBox )
		toolBox.yk_add( clearBtn )
		baseBox.yk_add( toolBox )
		baseBox.yk_add( spacer  )
		baseBox.yk_add( canvas  )
		basePan.yk_add( baseBox )
		yk_add( basePan )

		shapeSel.yk_set_minimum_size(    60, 10 )
		shapeSel.yk_set_maximum_size(   180, 40 )
		shapeSel.yk_set_preferred_size( [180,nil], [180,40] )
		shapeSel.yk_set_selected_index( 0 )
		sizSel.yk_set_preferred_size( [80, nil], [80, 20] )
		miscPane.yk_show( "line" )

		shapeSel.yk_set_listener( :fn_actionShapeSel )
		clearBtn.yk_set_listener( :fn_actionClearBtn )
		canvas  .yk_set_listener( :fn_actionCanvas  , :fn_trackCanvas )
		canvas  .yk_add_click_rect( 0, 0, 400, 600 )
	end

	def fn_actionShapeSel( prm_event )
		idx = yk_look('shapeSel').yk_selected_index()
		yk_look('shapeMisc').yk_show(ShapeKey[idx])
		yk_look('drawFill').yk_set_enabled( ShapeFill[idx] )
		df = (ShapeKey[idx] != 'img')

		YKLookButton.yk_find_objects('colorBtn').each() do |btn|
			btn.yk_set_enabled( df )
		end

		can = yk_look('canvas')
		if ShapeCursor[idx]
			can.yk_set_cursor( 'CROSSHAIR' )
		else
			can.yk_set_cursor( nil )
		end
		if idx == 6  # line mouse
			can.yk_set_track_mode( 'D', 'L' )
		else
			can.yk_set_track_mode( 'D', 'R' )
		end
	end
	def fn_actionClearBtn( prm_event )
		yk_look('canvas').yk_clear()
	end
	def fn_actionColorButton( prm_event )
		color = prm_event.yk_source().yk_fore()
		canvas = yk_look('canvas')

		canvas.yk_set_color( color )
		df = yk_look('drawFill').yk_is_selected()

		begin
			case yk_look('shapeSel').yk_selected_index()
				when 0 then fn_line( canvas )
				when 1 then fn_rect( canvas, df )
				when 2 then fn_oval( canvas, df )
				when 3 then fn_arc(  canvas, df )
				when 4 then fn_str(  canvas )
				when 5 then # nothing
				when 6 then yk_look( 'labColor' ).yk_set_fore( color )
				when 7 then yk_look( 'labColor' ).yk_set_fore( color )
			end
		rescue => ex
			yk_show_dialog_message( nil, ex.message() )
		end
	end
	def fn_line( prm_canvas )
		x1 = fn_intval( 'line1x' )
		y1 = fn_intval( 'line1y' )
		x2 = fn_intval( 'line2x' )
		y2 = fn_intval( 'line2y' )
		prm_canvas.yk_draw_line( x1, y1, x2, y2 )
	end
	def fn_rect( prm_canvas, prm_df )
		x1 = fn_intval( 'rect1x' )
		y1 = fn_intval( 'rect1y' )
		w1 = fn_intval( 'rect1w' )
		h1 = fn_intval( 'rect1h' )
		if prm_df
			prm_canvas.yk_fill_rect( x1, y1, w1, h1 )
		else
			prm_canvas.yk_draw_rect( x1, y1, w1, h1 )
		end
	end
	def fn_oval( prm_canvas, prm_df )
		x1 = fn_intval( 'rect1x' )
		y1 = fn_intval( 'rect1y' )
		w1 = fn_intval( 'rect1w' )
		h1 = fn_intval( 'rect1h' )
		if prm_df
			prm_canvas.yk_fill_oval( x1, y1, w1, h1 )
		else
			prm_canvas.yk_draw_oval( x1, y1, w1, h1 )
		end
	end
	def fn_arc( prm_canvas, prm_df )
		x1 = fn_intval( 'arc1x' )
		y1 = fn_intval( 'arc1y' )
		w1 = fn_intval( 'arc1w' )
		h1 = fn_intval( 'arc1h' )
		s1 = fn_intval( 'arc1s' )
		a1 = fn_intval( 'arc1a' )
		if prm_df
			prm_canvas.yk_fill_arc( x1, y1, w1, h1, s1, a1, 'pie' )
		else
			prm_canvas.yk_draw_arc( x1, y1, w1, h1, s1, a1, 'pie' )
		end
	end
	def fn_str( prm_canvas )
		x1  = fn_intval( 'str1x' )
		y1  = fn_intval( 'str1y' )
		str = yk_look( 'str1s' ).yk_text()
		fon = yk_look( 'fontSel' ).yk_selected_index()
		sty = yk_look( 'stySel' ).yk_selected_index()
		siz = fn_int( yk_look('sizSel' ).yk_selected_item() )
		f   = YKLookFont.new( FontStr[fon], StyKey[sty], siz )
		prm_canvas.yk_set_font( f )
		prm_canvas.yk_draw_string( str, x1, y1, 'TL' )
	end
	def fn_intval( prm_field )
		return fn_int( yk_look(prm_field).yk_text() )
	end
	def fn_int( prm_text )
		if prm_text.kind_of?(String)
			if prm_text =~ /^[0-9]+$/
				return prm_text.to_i()
			end
		end
		raise "̒lw肵Ă"
	end
	def fn_actionCanvas( prm_event )
		if yk_look('shapeSel').yk_selected_index() != 5
			return
		end
		btn = nil
		YKLookToggleButton.yk_find_objects().each() do |obj|
			if obj.yk_is_selected()
				btn = obj
			end
		end
		if btn.nil?()
			return
		end
		xy = prm_event.yk_xy()
		yk_look('canvas').yk_draw_image( btn.yk_icon(), xy[0], xy[1], 'CC' )
	end
	def fn_trackCanvas( prm_event )
		xy = prm_event.yk_xy()
		canvas = yk_look( 'canvas' )
		canvas.yk_set_color( yk_look('labColor').yk_fore() )
		idx = yk_look('shapeSel').yk_selected_index()
		if idx == 6  # line mouse
			canvas.yk_draw_line( xy[0..3] )
		end
		if idx == 7  # rect mouse
			if yk_look('drawFill').yk_is_selected()
				canvas.yk_fill_rect(xy[4..7])
			else
				canvas.yk_draw_rect(xy[4..7])
			end
		end
	end

	##def yki_laf_is_system()
	##	return false
	##end
	# def yki_fr_need_pack()
	#	return true
	# end
	# def yki_ht_farpath()
	#	return [ '/tools' , nil ]
	# end
end

YKLookMain.yk_mainloop( SimpleGraphic.new() )

#
# end of program
